VERSION 5.00
Begin VB.Form I2C 
   Appearance      =   0  'Flat
   BackColor       =   &H00C0C0C0&
   Caption         =   "PCF8591"
   ClientHeight    =   4335
   ClientLeft      =   1590
   ClientTop       =   1500
   ClientWidth     =   4005
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   Picture         =   "PCF8591.frx":0000
   ScaleHeight     =   289
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   267
   Begin VB.TextBox Text6 
      Height          =   495
      Left            =   2280
      TabIndex        =   11
      Text            =   "Text6"
      Top             =   1680
      Width           =   1215
   End
   Begin VB.TextBox Text5 
      Height          =   495
      Left            =   2280
      TabIndex        =   10
      Text            =   "Text5"
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox Text4 
      Height          =   495
      Left            =   360
      TabIndex        =   9
      Text            =   "Text4"
      Top             =   1680
      Width           =   1215
   End
   Begin VB.TextBox Text3 
      Height          =   495
      Left            =   360
      TabIndex        =   8
      Text            =   "Text3"
      Top             =   960
      Width           =   1215
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   375
      Left            =   360
      Max             =   255
      TabIndex        =   6
      Top             =   240
      Width           =   2295
   End
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   2400
      TabIndex        =   5
      Text            =   " "
      Top             =   3120
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   960
      TabIndex        =   2
      Text            =   "144"
      Top             =   3120
      Width           =   615
   End
   Begin VB.OptionButton Option1 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      Caption         =   "COM1"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   480
      TabIndex        =   0
      Top             =   2520
      Width           =   1095
   End
   Begin VB.OptionButton Option2 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      Caption         =   "COM2"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   2040
      TabIndex        =   1
      Top             =   2520
      Value           =   -1  'True
      Width           =   1095
   End
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   3120
      Top             =   2400
   End
   Begin VB.Label Label3 
      Caption         =   "0 V"
      Height          =   375
      Left            =   2760
      TabIndex        =   7
      Top             =   360
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "Ack"
      Height          =   375
      Left            =   1920
      TabIndex        =   4
      Top             =   3120
      Width           =   375
   End
   Begin VB.Label Label1 
      Caption         =   "Adr"
      Height          =   255
      Left            =   360
      TabIndex        =   3
      Top             =   3120
      Width           =   375
   End
End
Attribute VB_Name = "I2C"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Sub i2cStart()
    DTR 1  'SDA 0
    RTS 1  'SCL 0
End Sub

Sub i2cStop()
    DTR 1  'SDA 0
    RTS 0  'SCL 1
    DTR 0  'SDA 1
End Sub

Function i2cOut(Wert) As Integer
    i2cOut = 1       'kein Fehler
    Bit = 128
    For n = 1 To 8
      If (Wert And Bit) = 0 Then DTR 1 Else DTR 0
      RTS 0          'Clock
      RTS 1
      Bit = Bit / 2
    Next n
    DTR 0            'SDA 1
    RTS 0            '9. Clockimpuls fr Ack
    If CTS = 1 Then i2cOut = 0  'Fehler
    RTS 1
End Function

Sub i2cAck()
    DTR 1
    RTS 0     'Ack
    RTS 1
    DTR 0
End Sub

Sub i2cNak()
    DTR 0
    RTS 0:    'Nak
    RTS 1
End Sub

Function i2cIn()
    Bit = 128
    Wert = 0
    For n = 1 To 8
        RTS 0   'SCL
        If CTS = 1 Then Wert = Wert + Bit
        RTS 1
        Bit = Bit / 2
    Next n
    i2cIn = Wert
End Function

Private Sub Form_Load()
 i = OPENCOM("COM2:9600,N,8,1")
 If i = 0 Then
    i = OPENCOM("COM1:9600,N,8,1")
    Option1.Value = True
 End If
 If i = 0 Then MsgBox ("COM Error")
 Timer1.Interval = 500
End Sub

Private Sub Form_Unload(Cancel As Integer)
 TXD 0
 CLOSECOM
End Sub

Private Sub HScroll1_Change()
  DAdata = HScroll1.Value
  Label3.Caption = "DA= " + Str$(DAdata * 0.02) + " V"
End Sub

Private Sub Option1_Click()
 CLOSECOM
 i = OPENCOM("COM1:9600,N,8,1")
 If i = 0 Then MsgBox ("COM1 Error")
End Sub

Private Sub Option2_Click()
 CLOSECOM
 i = OPENCOM("COM2:9600,N,8,1")
 If i = 0 Then MsgBox ("COM2 Error")
End Sub

Private Sub Timer1_Timer()
  Adr = Val(Text1.Text)
  DAdata = HScroll1.Value
  i2cStart
  r = i2cOut(Adr) 'Bus-Adresse PCF8574
  If r = 0 Then Text2.Text = "Fehler" Else Text2.Text = "OK"
  i2cOut (68)     'Steuerbyte: DA aktiv, Messung ab Ch0
  i2cOut DAdata     'Daten zum Port
  i2cStop
  i2cStart
  r = i2cOut(Adr + 1) 'Bus-Adresse PCF8574 lesen
  Dummy = i2cIn       '1.Messung
  i2cAck
  Ch0 = i2cIn         'Daten von Ch0
  i2cAck
  Ch1 = i2cIn         'Daten von Ch1
  i2cAck
  Ch2 = i2cIn         'Daten von Ch2
  i2cAck
  Ch3 = i2cIn         'Daten von Ch3
  i2cNak
  i2cStop
  Text3.Text = "Ch0: " + Str$(Ch0 * 0.02) + " V"
  Text4.Text = "Ch1: " + Str$(Ch1 * 0.02) + " V"
  Text5.Text = "Ch2: " + Str$(Ch2 * 0.02) + " V"
  Text6.Text = "Ch3: " + Str$(Ch3 * 0.02) + " V"
End Sub

