
/* ======================================================================== */
/* Programm   :  ICONNECT                                                   */
/* Modul      :                                                             */
/* ------------------------------------------------------------------------ */
/* Funktion   :                                                             */
/* Entwickler :  Mathias Huser Mha / 06.07.1999                            */
/* Bugfix     :                                                             */
/*                                                                          */
/* ======================================================================== */

/* ------------------------------------------------------------------------ */
/* Windows, NT DDK, C, C++ Header Files                                     */
/* ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------ */
/* Definitionen                                                             */
/* ------------------------------------------------------------------------ */

#ifndef _NT_DEF_H_
#define _NT_DEF_H_

//////////////////////////////////////////////////////////////////////////////
// VxD interface internal version number

#define  VXD_IFC_VERSION  0x0004

//////////////////////////////////////////////////////////////////////////////
//
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
//

#define FILE_DEVICE_VXD  0x08890

//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
//

#define VXD_IOCTL_INDEX  0x0889


//////////////////////////////////////////////////////////////////////////////
// DeviceIoControl function codes for VxD driver

#define VXD_CODE(X) CTL_CODE(FILE_DEVICE_VXD, (VXD_IOCTL_INDEX+X), METHOD_BUFFERED, FILE_ANY_ACCESS)

#define VXD_CTL_GET_VERSION							   	VXD_CODE(1)
#define VXD_CTL_SCAN_START 						 				VXD_CODE(2)
#define VXD_CTL_DAQ_HALFREADY									VXD_CODE(3)
#define VXD_CTL_DAQ_TRANSFER          VXD_CODE(4)
#define VXD_CTL_DAQ_CLEAR             VXD_CODE(5)
#define VXD_CTL_DAQ_AI_SCAN           VXD_CODE(6)

#endif /* ndef _NT_DEF_H_ */



/* ------------------------------------------------------------------------ */
/* Ende der Datei                                                           */
/* ------------------------------------------------------------------------ */
