'**********************************************************
' C-Control Station
'
' Beispiel - einfache Schulklingelsteuerung
'
'  Eine Schule habe folgende Lehrzeiten:
'
'  1.Stunde  7.00 -  7.45
'  2.Stunde  7.55 -  8.40   anschliessend 20 min. Fruehstueckspause
'  3.Stunde  9.00 -  9.45
'  4.Stunde  9.55 - 10.40
'  5.Stunde 10.50 - 11.35   anschliessend 30 min. Mittagspause
'  6.Stunde 12.05 - 12.50
'  7.Stunde 13.00 - 13.45
'
' Begin und Ende einer Schulstunde soll ein Klingelsignal
' anzeigen, die Klingel ist an Relais K1 angeschlossen.
'
'**********************************************************

' die Relais
define klingelRelais port[7]


#loop

  wait second = 0

' 1. Stunde
  if (hour = 7) and (minute = 0) then klingelRelais = ON
  if (hour = 7) and (minute = 45) then klingelRelais = ON
  
' 2. Stunde
  if (hour = 7) and (minute = 55) then klingelRelais = ON
  if (hour = 8) and (minute = 40) then klingelRelais = ON
  
' Fruestueckspause  
  
' 3. Stunde
  if (hour = 9) and (minute = 0) then klingelRelais = ON
  if (hour = 9) and (minute = 45) then klingelRelais = ON
  
' 4. Stunde
  if (hour = 9) and (minute = 55) then klingelRelais = ON
  if (hour = 10) and (minute = 40) then klingelRelais = ON

' 5. Stunde
  if (hour = 10) and (minute = 50) then klingelRelais = ON
  if (hour = 11) and (minute = 35) then klingelRelais = ON
  
' Mittagspause  

' 6. Stunde
  if (hour = 12) and (minute = 05) then klingelRelais = ON
  if (hour = 12) and (minute = 50) then klingelRelais = ON

' 7. Stunde
  if (hour = 13) and (minute = 0) then klingelRelais = ON
  if (hour = 13) and (minute = 45) then klingelRelais = ON
  
  wait second = 20
  klingelRelais = OFF

goto loop




